/* astal-greet-0.1.vapi generated by valac 0.56.18, do not modify. */

[CCode (gir_namespace = "AstalGreet", gir_version = "0.1")]
namespace AstalGreet {
	/**
	 * Indicates that the request succeeded.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class AuthMessage : AstalGreet.Response {
		public enum Type {
			/**
			 * Indicates that input from the user should be
			 * visible when they answer this question.
			 */
			VISIBLE,
			/**
			 * Indicates that input from the user should be
			 * considered secret when they answer this question.
			 */
			SECRET,
			/**
			 * Indicates that this message is informative, not a question.
			 */
			INFO,
			/**
			 * Indicates that this message is an error, not a question.
			 */
			ERROR;
		}
		public string message { get; private set; }
		public AstalGreet.AuthMessage.Type message_type { get; private set; }
	}
	/**
	 * Cancels the session that is currently under configuration.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class CancelSession : AstalGreet.Request {
		public CancelSession ();
	}
	/**
	 * Creates a session and initiates a login attempted for the given user.
	 * The session is ready to be started if a success is returned.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class CreateSession : AstalGreet.Request {
		public CreateSession (string username);
		protected override string type_name { get; }
		public string username { get; set; }
	}
	/**
	 * Indicates that the request succeeded.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class Error : AstalGreet.Response {
		public enum Type {
			/**
			 * Indicates that authentication failed.
			 * This is not a fatal error, and is likely caused by incorrect credentials.
			 */
			AUTH_ERROR,
			/**
			 * A general error.
			 * See the error description for more information.
			 */
			ERROR;
		}
		public string description { get; private set; }
		public AstalGreet.Error.Type error_type { get; private set; }
	}
	/**
	 * Answers an authentication message.
	 * If the message was informative (info, error),
	 * then a response does not need to be set in this message.
	 * The session is ready to be started if a success is returned.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class PostAuthMesssage : AstalGreet.Request {
		public PostAuthMesssage (string response);
		public string response { get; set; }
		protected override string type_name { get; }
	}
	/**
	 * Base Request type.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public abstract class Request : GLib.Object {
		protected Request ();
		/**
		 * Send this request to greetd.
		 */
		public async AstalGreet.Response send () throws GLib.Error;
		protected abstract string type_name { get; }
	}
	/**
	 * Base Response type.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public abstract class Response : GLib.Object {
		protected Response ();
	}
	/**
	 * Requests for the session to be started using the provided command line,
	 * adding the supplied environment to that created by PAM.
	 * The session will start after the greeter process terminates
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class StartSession : AstalGreet.Request {
		public StartSession (string[] cmd, string[] env = new string[0] { });
		public string[] cmd { get; set; }
		public string[] env { get; set; }
		protected override string type_name { get; }
	}
	/**
	 * Indicates that the request succeeded.
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public class Success : AstalGreet.Response {
	}
	[CCode (cheader_filename = "astal-greet.h")]
	public const int MAJOR_VERSION;
	[CCode (cheader_filename = "astal-greet.h")]
	public const int MICRO_VERSION;
	[CCode (cheader_filename = "astal-greet.h")]
	public const int MINOR_VERSION;
	[CCode (cheader_filename = "astal-greet.h")]
	public const string VERSION;
	/**
	 * Shorthand for creating a session, posting the password,
	 * and starting the session with the given `cmd`
	 * which is parsed with [func@GLib.shell_parse_argv].
	 *
	 * @param username User to login to
	 * @param password Password of the user
	 * @param cmd Command to start the session with
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public static async void login (string username, string password, string cmd) throws GLib.Error;
	/**
	 * Same as [func@AstalGreet.login] but allow for setting additonal env
	 * in the form of `name=value` pairs.
	 *
	 * @param username User to login to
	 * @param password Password of the user
	 * @param cmd Command to start the session with
	 * @param env Additonal env vars to set for the session
	 */
	[CCode (cheader_filename = "astal-greet.h")]
	public static async void login_with_env (string username, string password, string cmd, string[] env) throws GLib.Error;
}
